﻿// <summary>ソースコード：ＨＹＭＣＯモデルファクトリクラス</summary>
// <author>CommonMP</author>

using System;
using System.Collections.Generic;
using System.Text;

using CommonMP.HYSSOP.Interface.HSData;
using CommonMP.HYSSOP.Interface.HSViewer;
using CommonMP.HYSSOP.CoreImpl.HSData;
using CommonMP.HYSSOP.CoreImpl.HSTools;

using CommonMP.HYMCO.Interface;
using CommonMP.HYMCO.Interface.Model;
using CommonMP.HYMCO.Interface.Data;
using CommonMP.HYMCO.Interface.Controller;

using CommonMP.HYSSOP.CoreImpl;
using CommonMP.HYMCO.CoreImpl.Model;
using CommonMP.HYMCO.CoreImpl.Data;

using CommonMP.HYMCO._SYSTEM_;

// ToDo namespace は　モデル開発者が変更して、ユニークな名称にして下さい
namespace CommonMP.HYMCO._SYSTEM_
{
    /// <summary><para>class outline:</para>
    /// <para>ＨＹＭＣＯモデルファクトリ生成</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2009/10/01][新規作成]</para>
    /// </remarks>
    public class HYMCO_MODEL_FACTORY_CREATOR_IMPLE : HYMCO_MODEL_FACTORY_CREATOR
    {
        /// <summary><para>method outline:</para>
        /// <para>コンストラクター</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> HYMCO_MODEL_FACTORY_CREATOR_IMPLE csFactCrt = new HYMCO_MODEL_FACTORY_CREATOR_IMPLE( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>生成インスタンス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public HYMCO_MODEL_FACTORY_CREATOR_IMPLE()
        {
        }
        /// <summary><para>method outline:</para>
        /// <para>演算モデルファクトリクラス生成</para>
        /// </summary>
        /// <example><para>usage:</para>
        /// <para> McModelFactory csCalModelFactory = CreateFactory( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>演算モデルファクトリクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public CommonMP.HYMCO.Interface.Model.McModelFactory CreateFactory()
        {
            return new jp.or.jccajsce.StorageFunctionRiver.StorageFunctionRiverFactory();
        }
    }
}

namespace jp.or.jccajsce.StorageFunctionRiver
{
    /// <summary><para>class outline:</para>
    /// <para>モデルファクトリクラス</para>
    /// </summary>
    /// <remarks><para>history:</para>
    /// <para>[CommonMP][ver 1.0.0][2008/10/01][新規作成]</para>
    /// </remarks>
    public class StorageFunctionRiverFactory : McBasicModelFactoryBase
    {
        /// <summary><para>method outline:</para>
        /// <para>ファクトリ識別子を生成</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para> HySID csFactID = CreateFactoryID( ) </para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>ファクトリ識別子</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override HySID CreateFactoryID()
        {
            // ToDo 本ファクトリクラスにユニークな識別子を生成して返してください
            return StorageFunctionRiverDefine.MODEL_FACTORY_LIB_ID;
        }

        /// <summary><para>method outline:</para>
        /// <para>演算モデルクラス生成</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para> McCalModel csCalModel = CreateCalModel(csModelKind) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>演算モデルクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalModel CreateCalModel(HySObjectKind csModelKind)
        {
            McBasicCalculateModelBase csCalModel = null;

            if (csModelKind.Equals(StorageFunctionRiverDefine.SFR_MODEL_KIND) == true)
            {
                csCalModel = new StorageFunctionRiver();
            }
            //<@Add_CreateCalModel/> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。
            else
            {
                // Do Nothing
            }
            return csCalModel;
        }

        /// <summary><para>method outline:</para>
        /// <para>要素内演算中データクラス生成</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para> McCalInfo csCalModel = CreateCalInfo( csModelKind ) </para>
        /// </example>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>要素内演算中データクラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCalInfo CreateCalInfo(HySObjectKind csModelKind)
        {
            McCalInfo csCalInfoData = null;

            if (csModelKind.Equals(StorageFunctionRiverDefine.SFR_MODEL_KIND) == true)
            {
                csCalInfoData = new StorageFunctionRiverCalInfo();
            }
            //<@Add_CreateCalInfo/> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。
            else
            {
                // Do Nothing
            }
            return csCalInfoData;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデルプロパティ表示／設定情報クラス生成</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para> McPropertyInfoRoot csPropertyInf = CreateModelPropertyInfo( csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>モデルプロパティ表示／設定情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McCellModelPropertyIF CreateModelProperty(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }

            StorageFunctionRiverPropertyInfo csRtnCellPrptyDt = null;

            if (csModelKind.Equals(StorageFunctionRiverDefine.SFR_MODEL_KIND) == true)
            {
                int pattern = 3;
                csRtnCellPrptyDt = new StorageFunctionRiverPropertyInfo(csLibraryID, csModelKind);
                csRtnCellPrptyDt.SetStepTime(3600); // δT設定
                csRtnCellPrptyDt.AddInfoType("m_lParaNum", Properties.Resources.STRING_PARA_NUM, McDefine.ValKind.LONG);
                csRtnCellPrptyDt.SetInfo("m_lParaNum", pattern);
                csRtnCellPrptyDt.AddInfoType("m_dTl", Properties.Resources.STRING_PARA_DATA1, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dTl", 0.5);
                csRtnCellPrptyDt.AddInfoType("m_dTlz", Properties.Resources.STRING_PARA_DATA2, McDefine.ValKind.DOUBLE);
                csRtnCellPrptyDt.SetInfo("m_dTlz", 0.5);

                SortedList<string, object> data = new SortedList<string, object>();
                double[] dData = new double[pattern];
                dData[0] = 28.3;
                dData[1] = 19.4;
                dData[2] = 4.2;
                data.Add("m_dSK", dData); // パラメータＫ
                dData = new double[pattern];
                dData[0] = 0.60;
                dData[1] = 0.79;
                dData[2] = 0.91;
                data.Add("m_dP", dData); // パラメータＰ
                dData = new double[pattern];
                dData[0] = 240.0;
                dData[1] = 520.0;
                dData[2] = 99999.0;
                data.Add("m_dQl", dData); // 適用区分(m3/s)
                csRtnCellPrptyDt.SetInfoSQData(data);

                //csRtnDt.AddInfoType("m_dData", "変数値", McDefine.ValKind.DOUBLE);
                //csRtnDt.SetInfo("m_dData", 99.9); 
                // ToDo 引数で与えられたモデル識別子に従って、プロパティ情報データを生成し、モデル固有設定値を設定して下さい。
                // 受信可能なパターン
                // ToDo　提供するモデルが受信可能なパターンを設定して下さい。
                {
                    // 第1パターン（1/2、1次元時系列）
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                      StorageFunctionRiverDefine.INFLOW,
                      McTranInfoDefine.D1_CELL_SERIAL,
                      Properties.Resources.STRING_INPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_INPUT_DATA, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR);
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);

                    // 第2パターン（2/2、ポイント時系列） 140924
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                      StorageFunctionRiverDefine.INFLOW_P,
                      McTranInfoDefine.SINGLE_CELL_SERIAL,
                      Properties.Resources.STRING_INPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(1);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_INPUT_DATA, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                        csTrnPtn.SetInterpolateType(HySDefine.InterpolateType.LINEAR);
                    }
                    csRtnCellPrptyDt.AddReceivePattern(csTrnPtn);
                }
                // 送信パターンの設定
                // ToDo　提供するモデルが送信可能なパターンを設定して下さい。
                {
                    // 第1パターン（1/2、1次元時系列）
                    McTranInfoPattern csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                      StorageFunctionRiverDefine.OUTFLOW,
                      McTranInfoDefine.D1_CELL_SERIAL,
                      Properties.Resources.STRING_OUTPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_OUTPUT_DATA1, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                            csCellChara.SetDataKind(1, Properties.Resources.STRING_OUTPUT_DATA2, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                            csCellChara.SetDataKind(2, Properties.Resources.STRING_OUTPUT_DATA3, HySDataKindDefine.WATER_VOLUME, "m3");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);

                    // 第2パターン（2/2、ポイント時系列） 140924
                    csTrnPtn = csRtnCellPrptyDt.CreateTranInforPattern(
                      StorageFunctionRiverDefine.OUTFLOW_P,
                      McTranInfoDefine.SINGLE_CELL_SERIAL,
                      Properties.Resources.STRING_OUTPUT_CATEGORY) as McTranInfoPattern;
                    {
                        // セル内変数設定
                        HySDataCharacteristicInCell csCellChara = csTrnPtn.CreateCellDataCharacteristic(3);
                        {
                            csCellChara.SetDataKind(0, Properties.Resources.STRING_OUTPUT_DATA1, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                            csCellChara.SetDataKind(1, Properties.Resources.STRING_OUTPUT_DATA2, HySDataKindDefine.QUANTITY_OF_WATER_FLOW, "m3/s");
                            csCellChara.SetDataKind(2, Properties.Resources.STRING_OUTPUT_DATA3, HySDataKindDefine.WATER_VOLUME, "m3");
                        }
                        csTrnPtn.SetCellDataCharacteristic(csCellChara);
                    }
                    csRtnCellPrptyDt.AddSendPattern(csTrnPtn);
                }
            }
            //<@Add_CreateModelProperty/> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。
            else
            {
                // Do Nothing
            }
            return csRtnCellPrptyDt;
        }

        /// <summary><para>method outline:</para>
        /// <para>モデル初期化表示／設定情報生成</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para> McPropertyInfoRoot csInitialInf = CreateModelInitialInfo( csLibraryID, csModelKind ) </para>
        /// </example>
        /// <param name="csLibraryID">ライブラリー識別子</param>
        /// <param name="csModelKind">モデル種別識別子</param>
        /// <returns>初期情報情報クラス</returns>
        /// <exception cref="">無し</exception>
        /// <remarks><para>remarks:</para>
        /// <para>無し</para>
        /// </remarks>
        public override McPropertyInfoRoot CreateModelInitialInfo(HySID csLibraryID, HySObjectKind csModelKind)
        {
            if (this.EqualFactory(csLibraryID) == false)
            {
                return null;
            }
            McInitialInfo csRtnDt = null;

            if (csModelKind.Equals(StorageFunctionRiverDefine.SFR_MODEL_KIND) == true)
            {
                csRtnDt = new StorageFunctionRiverInitialData(csLibraryID, csModelKind);
                // コーディング例
                // csRtnDt.AddInfoType("m_dData", "初期値", McDefine.ValKind.DOUBLE);
                // csRtnDt.SetInfo("m_dData", 1.0); 
                // ToDo　引数で与えられた　モデル識別子に従って、初期情報データを生成し、モデル固有設定デフォルト値を設定して下さい。
                csRtnDt.AddInfoType("m_dInitFlow_In", Properties.Resources.STRING_INIT_DATA1, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("m_dInitFlow_In", 34.0);

                csRtnDt.AddInfoType("m_dInitFlow_Out", Properties.Resources.STRING_INIT_DATA2, McDefine.ValKind.DOUBLE);
                csRtnDt.SetInfo("m_dInitFlow_Out", 40.0);
            }
            //<@Add_CreateModelInitialInfo/> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。
            else
            {
                // Do Nothing
            }
            return csRtnDt;
        }

        /// <summary>
        /// <para>method outline:</para>
        /// <para>モデル情報提供</para>
        /// </summary>
        /// <example>
        /// <para>usage:</para>
        /// <para>HySDataLinkedList csModelInfoList = GetCalModelInfoList();</para>
        /// </example>
        /// <param name="">無し</param>
        /// <returns>モデル情報のリスト</returns>
        /// <exception cref="">無し</exception>
        /// <remarks>
        /// <para>remarks:</para>
        /// <para>モデル情報(McModelInfo)をリスト形式で返却する</para>
        /// </remarks>
        public override HySDataLinkedList GetCalModelInfoList()
        {
            McModelInfo csModelInfo = null;

            csModelInfo = new McModelInfo(
                (HySID)this.GetFactoryID(),
                McModelLibraryDefine.DIVISION_CALCULATION_MODEL,    // <-- 演算モデルは、必ずこの値にして下さい（LibraryCategoryXML.xmlに記述されている）
 //               new HySObjectKind("CAL_MODELS"), // To Do   LibraryCategoryXML.xmlに定義されている値の中で、該当するモデル種別を設定してください
                McModelLibraryDefine.MODEL_CLASSIFICATION_CAL_RIVER,
                StorageFunctionRiverDefine.SFR_MODEL_KIND, // モデルの識別子
                StorageFunctionRiverDefine.SFR_MODEL_NAME  // モデルの名称
            );
            csModelInfo.SetVersionInf("1.0"); // モデルのバージョン
            csModelInfo.SetSummaryInf(Properties.Resources.STRING_MODEL_SUMMARY); // モデルの簡単な説明
            csModelInfo.SetIconName(new HySString("jp.or.jccajsce.StorageFunctionRiver_Factory/jp.or.jccajsce.StorageFunctionRiver")); // To Do モデル固有アイコン（アイコンを使用しないときは "DefaultModel" を設定してください）
            csModelInfo.SetCreatorInf("JCCAJSCE");
            csModelInfo.SetManualFileName(@"jp.or.jccajsce.StorageFunctionRiver_Factory/jp.or.jccajsce.StorageFunctionRiver.pdf"); // To Do モデル固有の解説情報等あれば設定してください。
            m_csCalModelInforList.AddLast(csModelInfo); // 演算モデル情報の追加
            //<@Add_GetCalModelInfoList/> ウイザードによる追加の目印　目印を削除しないで下さい　削除した場合には、モデルの追加は、手動で行う必要があります。
            return m_csCalModelInforList;
        }

    }
}
